<!-- Copyright 2023 Ross J. Duff MSc 
   The copyright holder licenses this file
   to you under the Apache License, Version 2.0 (the
   "License"); you may not use this file except in compliance
   with the License.  You may obtain a copy of the License at

      http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing,
   software distributed under the License is distributed on an
   "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
   KIND, either express or implied.  See the License for the
   specific language governing permissions and limitations
   under the License. -->

# Changelog

<!--next-version-placeholder-->

## v0.4.25 (2023-07-05)

### Fix

* :pencil2:(pyproject.toml): defer sphinxawesome-theme to ozi. ([`b1e144d`](https://github.com/rjdbcm/blastpipe/commit/b1e144d050f04f3887b1d64ac6a4f7454585792a))
* :pencil2:(README.rst): use blastpipe badge not OZI. ([`7a71e70`](https://github.com/rjdbcm/blastpipe/commit/7a71e70618441555406c574633e49b5e842309c8))

### Other

* 🔨(meson.build): enable subprojects/docs ([`0cd6483`](https://github.com/rjdbcm/blastpipe/commit/0cd6483a734fa6cc8a973faacaafec163f5d2a8f))
* 📝(README.rst): Add Contributing info. ([`96fec96`](https://github.com/rjdbcm/blastpipe/commit/96fec96befae2e886e7125c528b5a48a3b18019f))
* 👷semantic-release: pre_commit tox. ([`61b9362`](https://github.com/rjdbcm/blastpipe/commit/61b93629158e16697479312d91382d8e1b9c32ee))
* 🔇(CHANGELOG.md): Clean up version tags. ([`a3a50e2`](https://github.com/rjdbcm/blastpipe/commit/a3a50e2ae6826c1e57641a0d54ee0d69d229e7fe))
* PKG-INFO Updated ([`cf7cd18`](https://github.com/rjdbcm/blastpipe/commit/cf7cd18ea0aaed5182ad547b80efe791f2825967))

## v0.4.24 (2023-06-25)
### Other
* 🔨(semantic-release): git clean -dfX pre_commit. ([`230bb86`](https://github.com/rjdbcm/blastpipe/commit/230bb86a3e1899136fa7d1b854ccb12a0c986ca2))
* 🔊 Add 0.4.23 changes. CHANGELOG.md should actually get release notes from now on. ([`cdefd70`](https://github.com/rjdbcm/blastpipe/commit/cdefd70c105036b5c43a7588a2f47ecad9316a55))
* PKG-INFO Updated ([`55177f6`](https://github.com/rjdbcm/blastpipe/commit/55177f626333cf0322f0d89f0ff715f7cad10180))

## v0.4.23 (2023-06-24)
### Other
* PKG-INFO Updated ([`f80b3da`](https://github.com/rjdbcm/blastpipe/commit/f80b3da157f4a083922832e621b949a477238972))

## v0.4.21 (2023-06-23)
### Other
* PKG-INFO Updated ([`5c84048`](https://github.com/rjdbcm/blastpipe/commit/5c840485844fabc70b91c5be67d7b60ab4b864b0))

## v0.3.3 (2023-06-20)
### Other
* 👷 add dist/*tar.gz to release. ([`c98d198`](https://github.com/rjdbcm/blastpipe/commit/c98d198ea350f35d46085927525daf157d8e36ea))
* 👷 build wheel and sdist. ([`ec543a4`](https://github.com/rjdbcm/blastpipe/commit/ec543a4ed82ece555f7013b1ef0932fe4cb664d6))

## v0.3.2 (2023-06-20)
### Other
* 👷 stash and pop changelog for clean versioning. ([`8fcbd3f`](https://github.com/rjdbcm/blastpipe/commit/8fcbd3f4d34f660d257611f5dcf6078268818efa))
* Changelog updated ([`ae69bd4`](https://github.com/rjdbcm/blastpipe/commit/ae69bd4ac31ecad3f0225013bd8474b831c21260))

## v0.3.1 (2023-06-20)
### Other
* Changelog updated ([`022ab77`](https://github.com/rjdbcm/blastpipe/commit/022ab77c0cb9cadda63d34fd4bf8daff2c82460f))

## v0.3.0 (2023-06-20)
### Other
* 👷 move CHANGELOG commit to build step. ([`af2b566`](https://github.com/rjdbcm/blastpipe/commit/af2b56658ae00acbbf3791eaecbb57aa5295edcd))
* 👷 don't remove dist on semantic-release for now. ([`1460ff7`](https://github.com/rjdbcm/blastpipe/commit/1460ff76f2c9fda74f34ccd6277ebdeab31303df))
* 👷 checkpoint ([`cf1f010`](https://github.com/rjdbcm/blastpipe/commit/cf1f01080c6429053c69133cd0a3542c39d89c3a))
* 👷 only build wheel and test sdist no package upload for now. ([`955f8d0`](https://github.com/rjdbcm/blastpipe/commit/955f8d0b94856cadbb67ea93ed5b08b8ca4c4e25))

## v0.2.6 (2023-06-19)
### Other
* 👷 no repo upload on bump. ([`6c89b38`](https://github.com/rjdbcm/blastpipe/commit/6c89b38dc152bb6fee2c9c1b7bfbcb5326e0f0f4))

## v0.2.5 (2023-06-19)
### Other
* Revert readme section move ([`cac0748`](https://github.com/rjdbcm/blastpipe/commit/cac0748b875a923044a8f0ac8cda88aea7d9615a))
* Proper readme ([`1351fbc`](https://github.com/rjdbcm/blastpipe/commit/1351fbc5e936f448afd49f9133780d0150c7a6a5))

## v0.2.3 (2023-06-19)
### Other
* Change version regex ([`343bc20`](https://github.com/rjdbcm/blastpipe/commit/343bc2038bb8274e5e81b274fd9aa94ada96146d))

## v0.2.2 (2023-06-19)
### Other
* 👷 add version package pattern ([`66a0f49`](https://github.com/rjdbcm/blastpipe/commit/66a0f496ed94c5f4d6394c61bc968c2960b7431c))
* 👷 switch to ci commit versioning ([`b8bd455`](https://github.com/rjdbcm/blastpipe/commit/b8bd455a25e19f737f77de536d96cb7b055d2c40))

## v0.2.1 (2023-06-19)
### Other
* Changes to release. ([`fd26a79`](https://github.com/rjdbcm/blastpipe/commit/fd26a79002be80fe8ee150950bd761f03a109d2a))

## v0.2.0 (2023-06-19)
### Other
* Changelogged ([`af1cd00`](https://github.com/rjdbcm/blastpipe/commit/af1cd0033c9fbe0385c237de315cb4d52f866a60))

## v0.1.1 (2023-06-19)
### Other
* 🚨 lint for release test. ([`a292ad7`](https://github.com/rjdbcm/blastpipe/commit/a292ad70d4d5c9bf43e5d079558ddaba0b7a837b))
* 🚀 add testpypi and github artifact upload ([`4594834`](https://github.com/rjdbcm/blastpipe/commit/4594834abfd840168e1a6e65b6ef6d4164030065))
* 👷 add meson test and dist steps to semantic-release. ([`c2230dc`](https://github.com/rjdbcm/blastpipe/commit/c2230dc994177874aeaab8944fc1611d2930a9ec))
* 🧑‍💻 __init__.py now supplies __version__. Uses the version from importlib.metadata. ([`46705b7`](https://github.com/rjdbcm/blastpipe/commit/46705b7e6090dc897f198868a3527d19064f19d4))
* 🔨  scm_version updates. Meson writes fallback version and project name to pyproject.toml at dist time. ([`1c7ccc8`](https://github.com/rjdbcm/blastpipe/commit/1c7ccc87500c3b2def2fd19e128f7b996201ea88))
* 🚚 move vscode settings to subprojects/dev/ide ([`bd3a848`](https://github.com/rjdbcm/blastpipe/commit/bd3a848a7ddbf2b7b14aab3ec1a8823b8120073c))
* 🔨 docs no longer build_by_default. ([`12c4c6a`](https://github.com/rjdbcm/blastpipe/commit/12c4c6a2eea6f2b1e6ddf073c8d4cc26d6ac6ac6))
* 📄 Add license info to all remaining files ([`9cc6c02`](https://github.com/rjdbcm/blastpipe/commit/9cc6c027c826b868dbb7c3e399de5b7782fef698))
* Added 0.1.0 changes. ([`6b92237`](https://github.com/rjdbcm/blastpipe/commit/6b92237ad0ab02f4dbc56f6c8e922fc523f25ac2))

## v0.1.0 (2023-06-17)
### Breaking
* :boom: : Remove Partial Function Tail Call Removed the partial function tail call optimization. ([`75934ce`](https://github.com/rjdbcm/blastpipe/commit/75934ce0d3210b2ff43e059405cb104ca27cda01))
* :boom: Remove REST server This code is not able to be attributed to a license. ([`a7507eb`](https://github.com/rjdbcm/blastpipe/commit/a7507eb105c0739e9e195ae10302c88cfde87e1b))

### :boom:
* :boom: : Remove Partial Function Tail Call Removed the partial function tail call optimization. ([`75934ce`](https://github.com/rjdbcm/blastpipe/commit/75934ce0d3210b2ff43e059405cb104ca27cda01))
* :boom: Remove REST server This code is not able to be attributed to a license. ([`a7507eb`](https://github.com/rjdbcm/blastpipe/commit/a7507eb105c0739e9e195ae10302c88cfde87e1b))

### :chart_with_upwards_trend:
* :chart_with_upwards_trend: : Add tests/test_tailcall.py Added some unit tests. ([`2740872`](https://github.com/rjdbcm/blastpipe/commit/2740872f57ce9b452e6f4dbad8bc65545851652d))

### :bug:
* :bug: : Fix meson sources Removed rest35.py ([`de437f2`](https://github.com/rjdbcm/blastpipe/commit/de437f2b96146094e761bf28c2f2b3a041fe52c0))

### Other
* 🔨 Change sigstore test arg default to --version. ([`932da60`](https://github.com/rjdbcm/blastpipe/commit/932da604a67a18d9d171f2072b4cf268335c6c38))
* 🔨 pyproject tox ([`55667cf`](https://github.com/rjdbcm/blastpipe/commit/55667cf52fec23f8edbc0938a2dd881c8b25e762))
* 🔨 tox build update. ([`12ee347`](https://github.com/rjdbcm/blastpipe/commit/12ee34790c32d469ec647a597843b75f46f121b7))
* 🔨 add tox setuptools_scm. ([`90c197f`](https://github.com/rjdbcm/blastpipe/commit/90c197f59d34f9779624512a0ef78c95380bbaed))
* 🔨 Simplify options structure for OZI. ([`2302e1c`](https://github.com/rjdbcm/blastpipe/commit/2302e1c1e52fad5ab8ea2025b058806ddd5affa8))
* 📝 Fix doc autogen. ([`733797d`](https://github.com/rjdbcm/blastpipe/commit/733797dff4cb0142e491d7f9c10a75c60e97c6bd))
* ✅ Simplified tests module structure. ([`4d3b48b`](https://github.com/rjdbcm/blastpipe/commit/4d3b48b7a8aa6d3c1e74d64c1fc2e644e8759f12))
* 📄 Switch to Apache-2.0 license. ([`e4169c4`](https://github.com/rjdbcm/blastpipe/commit/e4169c44b7482832e9b20ac810157ac2912af475))
* 👷 dev subproject is now a true project ([`c0409db`](https://github.com/rjdbcm/blastpipe/commit/c0409db38fa8212126bb498ea2320b8b571c8425))
* 🔥 subprojects/dev/build.ninja: File deleted. ([`42d6ddb`](https://github.com/rjdbcm/blastpipe/commit/42d6ddbdab7173218f69c5bd888be11b8a36bfe5))
* ✅(tests): add test suite. ([`33d51d5`](https://github.com/rjdbcm/blastpipe/commit/33d51d5cdc4a594b4ed5bb883066872584b36050))
* 🚧🔨(subprojects/dev): Add snips and templates Added source python of meson options. ([`a10ffd6`](https://github.com/rjdbcm/blastpipe/commit/a10ffd62df15b3dcc49ce0929ed11ecb4d6ca33a))
* 🧑‍💻(vscode): add config add settings.json ([`c8806e8`](https://github.com/rjdbcm/blastpipe/commit/c8806e8e338af1104c116e639cf5da00c9efc683))
* 🙈 project: Only ignore top level dist/ dist/ changes to ./dist/ ([`41b4e74`](https://github.com/rjdbcm/blastpipe/commit/41b4e741ad5ca7cb20b4fc9a07512a3ca4d496a5))
* :memo: : Add docs folder add meson built sphinx-build ([`5f4d704`](https://github.com/rjdbcm/blastpipe/commit/5f4d704635d568d83e7b7c1841eaac0881014e19))
* Add proper license attribution. ([`685fdf9`](https://github.com/rjdbcm/blastpipe/commit/685fdf9fed68c77105bb5a554578690a5b16074a))
* :page_facing_up: : Add malloc.py license MIT required notice ([`9565c9b`](https://github.com/rjdbcm/blastpipe/commit/9565c9b6d5d0f893d85c0fd39c27ca933b6e1b0e))
* :memo: :rotating_light: : Doc & Lint Added docstrings and fixed linter complaints. ([`cce2432`](https://github.com/rjdbcm/blastpipe/commit/cce2432a14e95a0a7d9e23f2154c506bc286b7ef))
* Fix pyproject.toml ([`de64858`](https://github.com/rjdbcm/blastpipe/commit/de64858766d40197bdaceecb31819881cf9654c5))
* Fix again ([`c534fe1`](https://github.com/rjdbcm/blastpipe/commit/c534fe1dd9ad2b68622b721d4230220a7897b5b6))
* Fix ([`32a4953`](https://github.com/rjdbcm/blastpipe/commit/32a4953d5995f43a41a5c104ec3fbf3555df68b4))
* Fix pre_commit_command ([`38de9ca`](https://github.com/rjdbcm/blastpipe/commit/38de9caf32de315cdee8e6e9dd1d926df8e0f786))
* Fix pre_commit_command ([`fbd412f`](https://github.com/rjdbcm/blastpipe/commit/fbd412f34fc3b3b67fd2793218ccb419cfb86a0c))
* Update to our standardized meson build. ([`3e2fdb2`](https://github.com/rjdbcm/blastpipe/commit/3e2fdb2f7c32e99af57e33c10ac2a836054bbd8d))
* Meson build ([`2215879`](https://github.com/rjdbcm/blastpipe/commit/221587984b4e4bcf29ac6f9a19725e084777c712))
* Update buffer to drain after each write ([`a953cab`](https://github.com/rjdbcm/blastpipe/commit/a953cab768e58d2ec4fc8acd5d77e6ed49235d9c))
* Bump version ([`4457982`](https://github.com/rjdbcm/blastpipe/commit/445798218fdc06f6013e9584b2a5c18da30bf8be))
* Add gitattribute version ref ([`ca42210`](https://github.com/rjdbcm/blastpipe/commit/ca42210ae6f34d1c64f87fd857e205194348ea0e))
* Use -m pip call to build ([`dee7510`](https://github.com/rjdbcm/blastpipe/commit/dee75107ba28c5e28c86df656f111615e73d1f2e))
* Specify package in pyproject ([`da1a0c2`](https://github.com/rjdbcm/blastpipe/commit/da1a0c224e8a8b5ab6f3c3b4f2af82a53578cf72))
* Bump version ([`da8eb17`](https://github.com/rjdbcm/blastpipe/commit/da8eb172aeba06106bb9b33970e3d1faddcd8bd5))
* Fix import ([`9fe2054`](https://github.com/rjdbcm/blastpipe/commit/9fe2054ea30252f67ec2b2c66a3bf9f997986de0))
* Bump version to 2023.2.0b1 ([`5bd8dd9`](https://github.com/rjdbcm/blastpipe/commit/5bd8dd9e07b2d0a0ec42d261786b2185b6dbb4b2))
* Update build-system requirements ([`df6202b`](https://github.com/rjdbcm/blastpipe/commit/df6202bded6e531ab9788c15ae45e4c213568bc7))
* Changelog update ([`771109c`](https://github.com/rjdbcm/blastpipe/commit/771109c247b2037e2ea5de69d9e4687064ed51cf))
* Add changelog and scm ([`22a05f0`](https://github.com/rjdbcm/blastpipe/commit/22a05f078cbcd9fece946535fcb7fa832158de6c))
* Add markdownlint and pre-commit hooks ([`0ab4aad`](https://github.com/rjdbcm/blastpipe/commit/0ab4aade442b5291f383ee5d58e04988768d3231))
* Change project name to lemprex ([`37618c3`](https://github.com/rjdbcm/blastpipe/commit/37618c3f7f3c25073e5ae8df8ec6f213d0b2dae0))
* Fixed version typo ([`9204c01`](https://github.com/rjdbcm/blastpipe/commit/9204c01d379a30081cac9cd70d5a18425949f3b2))
* Added sequence.chr_union() ([`ec1a137`](https://github.com/rjdbcm/blastpipe/commit/ec1a137bd21baf454591d59ff67e52aaed8beee3))
* Init ([`6a541a2`](https://github.com/rjdbcm/blastpipe/commit/6a541a2c6f9aea0fe16b55fdf8d5c3ee8198116b))

## v2023.6.0 (2023-05-06)

* Switched to Meson build system
* No longer hard coding the version
